package domein;

public class AccountService
{
	private IAccountManager accountManager;

	public AccountService() 
	{
		this.accountManager = new AccountManager();
	}
	
	//SETTER Injection(dependency injection)
	public void setAccountManager(IAccountManager accountManager)
	{
		this.accountManager = accountManager;
	}

	public void transfer( String senderId, String beneficiaryId, long amount )
	{
		//! MOET WEG - Anders wordt onze Mock overschreven!
		//AccountManager accountManager = new AccountManager();
		//! MOET WEG - Anders wordt onze Mock overschreven!
		
		Account sender = accountManager.findAccountForUser( senderId );
		Account beneficiary = accountManager.findAccountForUser( beneficiaryId );
		sender.debit( amount );
		beneficiary.credit( amount );
		
		//Database:
		accountManager.updateAccount( sender );
		accountManager.updateAccount( beneficiary );
	} 
}